﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VezLego
{
    public class Kostka
    {
        public Color Barva { get; private set; }
        public int Sirka { get; private set; }
        public int Delka { get; private set; }

        public bool LzeOtocit
        {
            get
            {
                return Sirka != Delka;
            }
        }
        public int Plocha
        {
            get
            {
                return Sirka * Delka;
            }
        }


        public Kostka(Color barva, int sirka, int delka)
        {
            Barva = barva;
            Sirka = sirka;
            Delka = delka;
        }

        public Kostka Otocit()
        {
            return new Kostka(Barva, Delka, Sirka);
        }

        public bool VejdeSe(SpecifikaceVeze specifikace, bool otacet = true)
        {
            if (otacet)
            {
                return Sirka <= specifikace.X && Delka <= specifikace.Y && Otocit().VejdeSe(specifikace, false);
            }
            else
            {
                return Sirka <= specifikace.X && Delka <= specifikace.Y;
            }
        }
    }
}
