﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace VezLego
{
    public class KostkaSpecifikace : Kostka
    {
        public int Pocet { get; private set; }

        public List<int> Rozmery
        {
            get
            {
                return new List<int>() { Sirka, Delka };
            }
        }

        public KostkaSpecifikace(Color barva, int pocet, int sirka, int delka) : base(barva, sirka, delka)
        {
            Pocet = pocet;
        }

        public Kostka[] VytvoritKostky()
        {
            return Enumerable.Repeat(new Kostka(Barva, Sirka, Delka), Pocet).ToArray();
        }

        public override string ToString()
        {
            var barvy = OtocitBarvy(SpecifikaceVeze.DefinujBarvy());
            return string.Format("{0}  {1}x{2}  {3}",
                barvy[Barva],
                Sirka,
                Delka,
                Pocet);
        }

        private Dictionary<Color, char> OtocitBarvy(Dictionary<char, Color> barvy)
        {
            Dictionary<Color, char> slovnik = new Dictionary<Color, char>();
            foreach (var item in barvy)
            {
                slovnik.Add(item.Value, item.Key);
            }
            return slovnik;
        }
    }
}
