﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Drawing;

namespace VezLego
{
    public class SpecifikaceVeze
    {
        public int X { get; private set; }
        public int Y { get; private set; }
        public TypVeze Typ { get; private set; }
        public List<KostkaSpecifikace> Kostky { get; private set; }

        private SpecifikaceVeze(int x, int y, TypVeze typ, List<KostkaSpecifikace> kostky)
        {
            X = x;
            Y = y;
            Typ = typ;
            Kostky = kostky;
        }

        public static SpecifikaceVeze Parsuj(string soubor)
        {
            string[] radkySouboru = File.ReadAllLines(soubor);
            int x = 0, y = 0;
            List<KostkaSpecifikace> kostky = new List<KostkaSpecifikace>();
            TypVeze typ = TypVeze.D;

            Dictionary<char, Color> barvy = DefinujBarvy();
            for (int i = 0; i < radkySouboru.Length; i++)
            {
                if (!string.IsNullOrEmpty(radkySouboru[i]))
                {
                    string[] hodnoty = radkySouboru[i].Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
                    if (i == 0)
                    {
                        x = int.Parse(hodnoty[0]);
                        y = int.Parse(hodnoty[1]);
                        typ = (TypVeze)Enum.Parse(typeof(TypVeze), hodnoty[2]);
                    }
                    else
                    {
                        Color barva = barvy[hodnoty[0][0]];
                        string[] rozmer = hodnoty[1].Split('X');
                        int sirka = int.Parse(rozmer[0]);
                        int delka = int.Parse(rozmer[1]);
                        int pocet = int.Parse(hodnoty[2]);
                        kostky.Add(new KostkaSpecifikace(barva, pocet, sirka, delka));
                    }
                }
            }
            return new SpecifikaceVeze(x, y, typ, kostky);
        }

        public static Dictionary<Char, Color> DefinujBarvy()
        {
            Dictionary<char, Color> barvy = new Dictionary<char, Color>();
            barvy.Add('A', Color.FromArgb(0, 255, 255));
            barvy.Add('R', Color.FromArgb(255, 0, 0));
            barvy.Add('G', Color.FromArgb(0, 255, 0));
            barvy.Add('B', Color.FromArgb(0, 0, 255));
            barvy.Add('Y', Color.FromArgb(255, 255, 0));
            return barvy;
        }
    }
}
